@echo off

rem Batch file for Windows systems to make
rem the eposix.lib file

if "%1" == "" goto print_help

if "%1" == "-msc" goto msc
if "%1" == "-bcc" goto bcc
if "%1" == "-lcc" goto lcc
goto print_help

:msc
echo Make sure the Makefile src/cap/Makefile.msc
echo contains the correct flag for the Eiffel compiler
echo you want to use. The default is ISE.
goto compiler_known

:bcc
echo Make sure the Borland make is the first make.exe in your 
echo path. Also bcc32.exe should be in your path.
echo And bcc32.cfg should be setup correctly 
echo (see the readme.txt supplied by Borland).
echo Make sure Makefile.bcc contains the correct flag for 
echo the Eiffel compiler you want to use. 
echo The default is ISE.
goto compiler_known

:lcc
echo Make sure lcc's make is the first make.exe in your 
echo path.
echo You probably have to change the SEDIR variable to point
echo to your SmallEiffel directory.
goto compiler_known


:compiler_known

:vendor_known
if exist libeposix.lib del libeposix.lib
if "%1" == "-bcc" make -f Makefile.bcc 
if "%1" == "-msc" nmake -f Makefile.msc 
if "%1" == "-lcc" make -f Makefile.lcc
if not exist libeposix.lib goto no_success
goto end

:no_success
echo Creating the library was not successful.
goto end

:print_help
echo You have to provide the compiler and Eiffel vendor.
echo .
echo Compile with Borland C for ISE Eiffel:
echo   makelib -bcc
echo .
echo Compile with Microsoft Visual C compiler for VisualEiffel:
echo   makelib -msc
echo .
echo Compile with lcc C compiler for SmallEiffel:
echo   makelib -lcc

:end
