indexing

   description: "Class that covers POSIX process related routines."

   author: "Berend de Boer"
   date: "$Date: Thu, 12 Oct 2000 20:41:01 +0200 $"
   revision: "$Revision: 1.6 $"

deferred class 

   POSIX_PROCESS

inherit
   
   STDC_PROCESS

   POSIX_BASE

   PAPI_SIGNAL

   PAPI_UNISTD

   PAPI_WAIT
   

feature -- process properties
   
   pid: INTEGER is
         -- the process identifier
      require
         valid_pid: is_pid_valid
      deferred
      ensure
         valid_pid: Result > 0
      end
   
   is_pid_valid: BOOLEAN is
         -- return True if this process has a correct pid
      do
         Result := True
      end
   

feature -- signal this process
   
   kill (a_signal_code: INTEGER) is
         -- Send signal `signal_code' to the process
      require
         valid_signal: a_signal_code >= 0
         -- not_terminated: not is_terminated
      do
         safe_call (posix_kill (pid, a_signal_code))
      end
   
   terminate is
         -- attempt to gracefully terminate this process
      do
         safe_call (posix_kill (pid, SIGTERM))
      end


invariant
   
   -- don't attempt to check this invariant
   -- valid_pid: pid >= 0
   
end -- class POSIX_PROCESS
