indexing

	description: "Class that covers Posix stat structure."

  author: "Berend de Boer"
	date: "$Date: Fri, 13 Oct 2000 13:36:48 +0200 $"
	revision: "$Revision: 1.3 $"

deferred class 

   POSIX_STATUS

   
inherit
   
   POSIX_BASE

   PAPI_STAT


feature {NONE} -- creation   
   
   make_stat is
      do
         create stat.allocate (stat_size)
      end


feature
   
   refresh is
         -- refresh the cached information
      deferred
      end


feature -- stat members

   ino, inode: INTEGER is
      do
         Result := posix_st_ino (stat.ptr)
      end

   mtime, modification_time, change_date: INTEGER is
         -- Unix time
      do
         Result := posix_st_mtime (stat.ptr)
      end

   permissions: POSIX_PERMISSIONS is
         -- file permissions
      deferred         
      ensure
         valid_result: Result /= Void
      end

   size: INTEGER is
         -- size of file in bytes
      do
         Result := posix_st_size (stat.ptr)
      end


feature -- direct access to the unix fields, not recommended

   unix_gid: INTEGER is
      do
         Result := posix_st_gid (stat.ptr)
      end
   
   unix_mode: INTEGER is
      do
         Result := posix_st_mode (stat.ptr)
      end
   
   unix_uid: INTEGER is
      do
         Result := posix_st_uid (stat.ptr)
      end


feature {NONE} -- state

   stat: STDC_DYNAMIC_MEMORY


invariant 
   
    valid_stat: stat /= Void

end -- class POSIX_STATUS
