indexing

   description: "Class that covers the Standard C system command, %
   %i.e. interaction with the shell."

   author: "Berend de Boer"
   date: "$Date: Thu, 14 Sep 2000 17:06:24 +0200 $"
   revision: "$Revision: 1.3 $"

class 

   STDC_SHELL_COMMAND
   
inherit

   STDC_CHILD_PROCESS

   CAPI_STDLIB


creation
   
   make
   
   
feature -- creation
   
   make (a_command: STRING) is
         -- set command to execute. Command is not subject to expansion
      require
         valid_command: a_command /= Void and then not a_command.is_empty
      do
         command := a_command
      end


feature -- execute the command
   
   execute is
         -- execute a command. Error reporting is system dependent.
      do
         exit_code := posix_system (sh.string_to_pointer (command))
         terminated := True
      end


feature -- local state
   
   command: STRING


feature -- termination info
   
   exit_code: INTEGER


end -- class STDC_SHELL_COMMAND
