indexing

   description: "Test Posix mkfifo and forking."

   author: "Berend de Boer"
   date: "$Date: Thu, 12 Oct 2000 20:41:01 +0200 $"
   revision: "$Revision: 1.2 $"

class 

   TEST_P_FORK


inherit
   
   POSIX_CURRENT_PROCESS
   
   POSIX_FILE_SYSTEM
      rename
         make as make_file_system
      end
   

creation
   
   make
   

feature

   make is
         -- prepare stuff
      local
         reader: POSIX_TEXT_FILE
         stop_sign: BOOLEAN
         child: TEST_P_FORK_CHILD
      do
         make_file_system
         
         -- necessary under SmallEiffel
         ignore_child_stop_signal
         
         print ("My pid: ")
         print (pid)
         print ("%N")

         unlink ("berend.tmp")
         print ("Make a fifo.%N")
         make_fifo ("berend.tmp", S_IRUSR + S_IWUSR)
         create child
         print ("Fork object.%N")
         fork (child)
         print ("child pid: ")
         print (child.pid)
         print ("%N")
         
         -- we will now block until file is opened for writing
         create reader.open_read ("berend.tmp")
         from
            stop_sign := False
         until
            stop_sign
         loop
            reader.read_string (128)
            print (reader.last_string)
            stop_sign := equal(reader.last_string, "stop%N")
         end
         reader.close
         
         -- now wait for the writer to terminate
         child.wait_for (True)
         
         unlink ("berend.tmp")
      end
   
   
end -- class TEST_P_FORK
